#!/usr/bin/lua
--[[
csv-t alakit html- vagy wiki-tablazatta. Csak a tablazat belsejet: a fejlecet nem es a tabla veget nem.

Parameter: file.csv { html | wiki }

Ha nincs oszlopstilus stdin-en, </dev/null -lal kell hivni.

stdin-rol olvassa be az oszlopok stilusait. A bemenet minden sora a tablazat egy-egy oszlopanak stilusa:
	wiki-ben: || sor |
	html-ben: <td sor>
Peldaul: style="text-align: right"

Ha a mezoben | van, a | elotti resz a felirat, az utani a link.
]]

if not arg[2] or (arg[2] ~= 'html' and arg[2] ~= 'wiki')
then	print('Hivas: csv-file { wiki | html }')
	os.exit(1)
end

stilus = {}	-- oszlopstilusok tombje
i = 1
for line in io.lines()
do
        if string.gsub(line,' ','') ~= ''
	then	stilus[i] = line
	end
	i = i+1
end

require('strspn')
for line in io.lines(arg[1])
do
	sor = {}
        strspn(line,sor,'	')
	if arg[2] == 'wiki' then s = '|-\n| ' else	s = '<tr>' end	-- sor eleje
	for i,mezo in ipairs(sor)
	do	szoveg = string.match(mezo,'^[^|]*')	-- a mezo szovege a link nelkul. Nem lehet ures.
		link   = string.match(mezo,'|(.*)')	-- a mezo linkje. Lehet ures.
		--print(i,mezo)
		if arg[2] == 'wiki'	-- mezo fejlec
		then	if link and link ~= ''
			then	szoveg = '['..string.gsub(link,' ','%%20')..' '..szoveg..']'
			end
			if i > 1 then s = s..' || ' end
		else	if link and link ~= ''
			then	szoveg = '<a href="'..link..'">'..szoveg..'</a>'
			end
			s = s..'\n	<td'
		end
		if stilus[i]		-- mezo stilus
		then	s = s..' '..stilus[i]
			if arg[2] == 'wiki' then s = s..' | '
			end
		end
		if arg[2] == 'html' then s = s..'>' end
		s = s..szoveg		-- a mezo erteke
		if arg[2] == 'html' then s = s..'</td>' end	-- mezo vege
	end
	if arg[2] == 'html' then s = s..'</tr>' end
	print(s)
end
